
///
/// Clases publicas:
/// *
/// Metodos públicos:
///  CHT.rellenaBocadillo
///  CHT.editarHandler
///  CHT.borrarHandler


(function($cht) {

    var $ = $cht.jQuery;

    // Manejadores de eventos del bocadillo
    $cht.editarHandler = editarHandler;
    $cht.borrarHandler = borrarHandler;

    $cht.rellenaBocadillo = rellenaBocadillo;


    // solo puede haber un bocadillo activo en esta versión.
    // Datos sobre el contexto del bocadillo actual
    var _currentFeature;  // feature que está siendo mostrada
    var _editarHandler;
    var _borrarHandler;

    /**
     *
     * @param feature
     * @param editarHandler
     * @param borrarHandler
     */
    function rellenaBocadillo(feature, editarHandler, borrarHandler) {

        _currentFeature = feature;
        _editarHandler = editarHandler;
        _borrarHandler = borrarHandler;

        var data = feature.properties;

        var mainDiv = $("#plantilla_popup")[0];

        cambiarCampo("pmspcod");
        cambiarCampo("pmspnom");
        cambiarCampo("cartodb_id");
        // TODO - campos todos los tipo y data-tipo y input-tipo  por grupo
        cambiarCampo("tipo"); // nombre de campo coindice con id del elemento html
        cambiarCampo("descripcion");

        var copy = document.createElement("DIV");
        copy.innerHTML = mainDiv.outerHTML;;
        return copy;
   
        // Cambia el valor de un campo del bocadillo
        function cambiarCampo(nomCampo) {
            var jqDiv = $("#dato-" + nomCampo);
	        if (jqDiv.length===0) {
	            console.error("no encontrado campo: " + nomCampo);
		        return;
	        }
            var campoDiv = jqDiv[0];
	        var valor = data[nomCampo];
	        if (typeof valor === 'undefined') {
	            // mostrar log de  no existe
                valor = "...";
	        }
            // caso especial para el campo Grupo
            if (nomCampo=="tipo") {  // TODO - sustituir por grupo
                valor = "(" + valor + ") " + CHT.getDescripcionGrupo(valor);
            }
            campoDiv.innerText = valor;
       }
    }

    // invocado desde el código manejador de evento escrito en el propio bocadillo
    function borrarHandler(evt) {
         var ident = _currentFeature.properties.pmspcod + " - " + _currentFeature.properties.pmspnom +
             " (geom:" + _currentFeature.geometry.type + ")";
         
         if (window.confirm("Borrar la presión: " + ident + "\n\n¿Seguro?")) {
             _borrarHandler.call($cht, _currentFeature, {});
         }

    }

    // invocado desde el código manejador de evento escrito en el propio bocadillo
    function editarHandler(evt) {
        _editarHandler.call($cht, _currentFeature, {});
    }


    function pideUltimaMedida() {

        $.getJSON('http://lourdes.cartodb.com/api/v2/sql/?q='+sql_statement, function(data){
            $.each(data.rows, function(key, val) {
            // do something!
            });
        });
   
    }


})(CHT);

/*

Ejemplo para a�adir en modo texto a cartodb. Buscar modelo
      {"type": "Polygon", "coordinates":[[
      [-3.0, 38.0], -3.7, 39.0], [-3.4,40.0], [-3.0, 41.0]
      ]]}
	  
	  
	  */