
//
// Closure para Grupos.
// Represneta la tabla Grupos que permite diferenciar distintos tipos de presiones
//

(function($cht) {

    $cht.rellenaComboGrupos = rellenaComboGrupos;

    $cht.getDescripcionGrupo = getDescripcionGrupo;

    $cht.getEstiloPoligono = getEstiloPoligono;

    $cht.getEstiloLinea = getEstiloLinea;

    $cht.getEstiloCssPunto = getEstiloCssPunto;

    function rellenaComboGrupos(selectDom) {
        selectDom.innerHTML = "";
        var optNula = createOption("Elige opcion ...", 0);
        selectDom.appendChild(optNula);
        for (key in GRUPOS) {
            if (key) {
                var opt = createOption(GRUPOS[key], key);
                selectDom.appendChild(opt);
            }
        }
    }

    function getDescripcionGrupo(codigo) {
        var key = "" + codigo;
        var value = GRUPOS[key];
        return value || ("grupo no encontrado: " + codigo);
    }

    function createOption(texto, valor) {
        var opt = document.createElement("option");
        opt.value = valor;
        opt.innerText = texto;
        return opt;
    }

    /**
     * Devuelve los estilos css asociados a la presion puntual según su tipo o subtipo
     * @param feature
     */
    function getEstiloCssPunto(feature) {
        var subTipo = feature.properties.tipo;
        var superTipo = ("" + feature.properties.tipo).substring(0,1) + "00";
        var cssName = "t-000 t-" + superTipo + " t-" + subTipo;
        return cssName;
    }

    function getEstiloPoligono(feature) {
        var subTipo = feature.properties.tipo;
        var superTipo = ("" + feature.properties.tipo).substring(0,1) + "00";
        var style= TIPOS_POLIG_ESTILOS[subTipo];
        if (style===undefined) {
            style= TIPOS_POLIG_ESTILOS[superTipo];
        }
        return style;
    }

    function getEstiloLinea(feature) {
        var subTipo = feature.properties.tipo;
        var superTipo = ("" + feature.properties.tipo).substring(0,1) + "00";
        var style= TIPOS_LINEA_ESTILOS[subTipo];
        if (style===undefined) {
            style= TIPOS_LINEA_ESTILOS[superTipo];
        }
        return style;
    }

    // Variables internas en este closur

    var GRUPOS = {
    "100": "GRUPO 1. Fuentes puntuales significativas",
    "101": "Vertidos",
    "102": "Vertederos",
    
    "200": "GRUPO 2. Fuentes difusas significativas",
    "201": "Agricultura",
    "202": "Ganadería",
    "203": "Aeropuertos",
    "204": "Vías de transporte",
    "205": "Suelos contaminados",
    "205": "Zonas urbanas",
    "206": "Zonas mineras",
    "207": "Zonas recreativas",
    "208": "Praderas",
    "209": "Gasolineras",
    
    "300": "GRUPO 3. Extracciones de agua significativas",
    "301": "Concesiones de agua",

    "400": "GRUPO 4. Regulaciones del flujo de agua significativas",
    "401": "Regulación embalses",
    "402": "Desvíos Hidroeléctricos",
    "403": "Incorporación por",
    "404": "Trasvases",

    "500": "GRUPO 5. Alteraciones morfológicas significativas",
    "501": "Presas",
    "502": "Azudes",
    "503": "Puentes",
    "504": "Canalizaciones",
    "505": "Protección Márgenes",
    "506": "Dragados",
    "507": "/Recrecimiento Lagos",
    "508": "Modificación conexiones",
    "509": "Coberturas cauces",

    "600": "GRUPO 6. Otras incidencias antropogénicas significativas",
    "601": "Especies alóctonas",
    "601": "Sedimentos contaminados",
    "602": "Actividades recreativas",

    "700": "GRUPO 7. Usos del suelo",
    "701": "Incendios Forestales",
    "702": "Explotación Forestal",
    "703": "Ocupación Márgenes",
    "704": "Extracción Áridos",
    "705": "Otros Elementos"

    };


    var TIPOS_POLIG_ESTILOS = {
        "100" : { color: "#7F6900"},
        "200" : { color: "#2B6373"},
        "300" : { color: "#FF825B"},
        "400" : { color: "#FF5BCA"},
        "500" : { color: "#905BFF"},
        "600" : { color: "#5BEBFF"},
        "700" : { color: "#D8D39C"}
    };

    var TIPOS_LINEA_ESTILOS = {
        "100" : { color: "#7F6900"},
        "200" : { color: "#2B6373"},
        "300" : { color: "#FF825B"},
        "400" : { color: "#FF5BCA"},
        "500" : { color: "#905BFF"},
        "600" : { color: "#5BEBFF"},
        "700" : { color: "#D8D39C"}
    };

})(CHT)

// requerido existencia de variable CHT como objeto

